#ifndef TODO_H__
#define TODO_H__

#include <stdexcept>
#include <string>
#include <set>
#include <sys/types.h>

using namespace std;

/*
	Todo is the basic data structure for each entry in the .todo database.

	01/02/01	Initial creation
*/

class Todo {
	public :
		friend class TodoDB;

		class exception : public runtime_error { public : exception(char const *what) : runtime_error(what) {} };

		enum Priority {
			None = -1,
			VeryLow = 0,
			Low,
			Medium,
			High,
			VeryHigh
		};

		Todo();
		~Todo();

		int operator < (Todo const &other) const;
		int operator == (Todo const &other) const;

		void incUnFilteredChildren();
		void decUnFilteredChildren();

		// this is saved
		Priority priority;
		string text;
		bool done;
		time_t added, doneTime;

		// not saved to xml
		int index, unfilteredchildren;
		bool filtered;

		multiset<Todo> child, *in;
		Todo *parent;
};

#endif
